SystemOrganization addCategory: #BackgammonView!

Morph subclass: #BackgammonBoard
	instanceVariableNames: 'length surface current points checkers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BackgammonBoard commentStamp: 'DavidOvergaard 7/14/2015 19:08' prior: 0!
This class draws the backgammon board!

!BackgammonBoard class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:30'!
createNewBoard
	^BackgammonBoard new openInWorld.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:55'!
addCheckerAtPoint: pointNum color: aColor
	| aChecker pointWidth temp_loc |	
	pointWidth := (((surface width)/17) asInteger).
	temp_loc := (points at: pointNum) location copy.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	aChecker := BChecker diameter: (pointWidth * 0.9) location: temp_loc color: aColor.
	checkers add: aChecker.
	self addMorph: (aChecker shape).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:56'!
backgroundColor
	^(Color r: 0.69 g: 0.45 b: 0.26)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
boardRatio
	^0.75.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:44'!
createBottomPointsWidth: pointWidth height: pointHeight
	| x_loc x_offset y_loc |
		
	x_loc := (surface width) - (pointWidth / 2).
	x_offset := pointWidth * 2.
	x_loc := x_loc - x_offset.
	y_loc := (surface height).
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self evenPointsColor)).
		x_loc := x_loc - pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self oddPointsColor)).
		x_loc := x_loc - pointWidth.
	].
	
	x_loc := x_loc - x_offset.
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self evenPointsColor)).
		x_loc := x_loc - pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: 1 color: (self oddPointsColor)).
		x_loc := x_loc - pointWidth.
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
createPoints
	| pointWidth pointHeight |
	
	points := OrderedCollection new.
	
	pointWidth := (((surface width)/17) asInteger).
	pointHeight := ((surface height / 2) * (-0.9)).
	
	self createBottomPointsWidth: pointWidth height: pointHeight.
	self createTopPointsWidth: pointWidth height: pointHeight.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
createTopPointsWidth: pointWidth height: pointHeight
	| x_loc x_offset y_loc |
	
	x_loc := pointWidth / 2.
	x_offset := (surface width - (16 * pointWidth)).
	x_loc := x_loc + x_offset.
	y_loc := 0.
	
	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self evenPointsColor)).
		x_loc := x_loc + pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self oddPointsColor)).
		x_loc := x_loc + pointWidth.
	].

	x_loc := x_loc + (pointWidth * 2).

	1 to: 3 do: [ :x |
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self evenPointsColor)).
		x_loc := x_loc + pointWidth.
		
		points add: (BackgammonPoint width: pointWidth height: pointHeight location: x_loc@y_loc pointsUp: -1 color: (self oddPointsColor)).
		x_loc := x_loc + pointWidth.
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:38'!
drawOn: aCanvas
	self render.
	
	aCanvas drawImage: surface asForm at: self bounds origin.

"	pointWidth := (((surface width)/17) asInteger).
	temp_loc := (points at: 2) location.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	checker1 := BChecker diameter: (pointWidth * 0.9) location: temp_loc color: (Color red).
	self addMorph: (checker1 shape)."! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:57'!
evenPointsColor
	^(Color r: 0.93 g: 0.78 b: 0.62)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
getBoardSize
	"Ratio based on maximum Danish Backgammon Federation tournament size: http://www.bkgm.com/rgb/rgb.cgi?view+842"
	^(self length)@((self boardRatio)*(self length)).! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:55'!
initialize
	super initialize.
	self length: 1000.
	self extent: (self getBoardSize).
	self color: (self backgroundColor).
	surface := AthensCairoSurface extent: (self extent).
	checkers := OrderedCollection new.

	self createPoints.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:01'!
length
	^length.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:34'!
length: aValue
	length := aValue.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:46'!
moveCheckerNum: checkerIdx toPoint: pointNum	
	| aChecker pointWidth temp_loc |	
	pointWidth := (((surface width)/17) asInteger).
	temp_loc := ((points at: pointNum) location) copy.
	temp_loc setX: (temp_loc x) - (pointWidth * 0.9 / 2) setY: (temp_loc y) - (pointWidth * 0.9).
	
	aChecker := checkers at: checkerIdx.
	(aChecker shape) position: temp_loc.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 19:57'!
oddPointsColor
	^(Color r: 0.43 g: 0.31 b: 0.2)! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
points
	^points.! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:43'!
render
	surface drawDuring: [:canvas|
		surface clear: (self backgroundColor).
		
		points do: [ :aPoint |
			canvas setShape: (aPoint shape).
			canvas setPaint: (aPoint color).
			canvas draw.
		 ].
	].! !

!BackgammonBoard methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 20:00'!
width
	^(length * (self boardRatio)).! !

Object subclass: #BChecker
	instanceVariableNames: 'mouseAction diameter location shape color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BChecker commentStamp: '<historical>' prior: 0!
checker!

!BChecker class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 20:36'!
diameter: checkerDiameter location: centerLocation color: aColor
	^BChecker new diameter: checkerDiameter location: centerLocation color: aColor.! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 20:54'!
color
	^color! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:56'!
diameter: checkerDiameter location: centerLocation color: aColor
	diameter := checkerDiameter.
	location := centerLocation.
	color := aColor.
	
	shape := CircleMorph new color: (self color); 
					borderWidth: 0; 
					left: ((self location) x);
					top: ((self location) y);
					extent: (diameter@diameter).! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 20:54'!
initialize
	super initialize.! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 20:46'!
location
	^location! !

!BChecker methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 20:51'!
shape
	^shape! !

Object subclass: #BackgammonPoint
	instanceVariableNames: 'location shape color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonView'!

!BackgammonPoint commentStamp: 'DavidOvergaard 7/14/2015 20:02' prior: 0!
A backgammon point!

!BackgammonPoint class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:00'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp
	^BackgammonPoint new width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp.! !

!BackgammonPoint class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:22'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor
	^BackgammonPoint new width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:23'!
color
	^color! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/14/2015 22:53'!
initialize
	super initialize.! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:10'!
location
	^location! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:02'!
shape
	^shape! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:09'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp
	| surface |
	
	location := centerLocation.
	
	"Need a surface to use shape creation"
	surface := AthensCairoSurface extent: 0@0.

	shape := surface createPath: [:builder |
		builder 
			moveTo: centerLocation;
			lineTo: (pointWidth/2)@0;
			lineTo: (-1*(pointWidth/2))@(pointHeight * pointsUp);
			lineTo: (-1*pointWidth/2)@(-1 * (pointHeight * pointsUp));
			close
		].! !

!BackgammonPoint methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/15/2015 19:23'!
width: pointWidth height: pointHeight location: centerLocation pointsUp: pointsUp color: aColor
	| surface |
	
	location := centerLocation.
	color := aColor.
	
	"Need a surface to use shape creation"
	surface := AthensCairoSurface extent: 0@0.

	shape := surface createPath: [:builder |
		builder 
			moveTo: centerLocation;
			lineTo: (pointWidth/2)@0;
			lineTo: (-1*(pointWidth/2))@(pointHeight * pointsUp);
			lineTo: (-1*pointWidth/2)@(-1 * (pointHeight * pointsUp));
			close
		].! !
